<template>
  <q-input
    filled
    dense
    v-model="internalValue"
    @input="updateValue"
    :hide-bottom-space="hideBottomSpace"
    :error-message="errorMessage"
    :error="error"
  >
    <template v-slot:append>
      <q-icon name="event" class="cursor-pointer">
        <q-popup-proxy cover transition-show="scale" transition-hide="scale">
          <q-date
            v-model="internalValue"
            @update:model-value="updateValue"
            mask="YYYY-MM-DD"
          >
            <div class="row items-center justify-end">
              <q-btn v-close-popup label="Close" color="primary" flat />
            </div>
          </q-date>
        </q-popup-proxy>
      </q-icon>
    </template>
  </q-input>
</template>

<script lang="ts">
import { defineComponent, PropType, ref, toRefs, watch } from 'vue';

export default defineComponent({
  name: 'InputDate',
  props: {
    modelValue: {
      type: String as PropType<string>,
      required: true,
    },
    error: {
      type: Boolean as PropType<boolean>,
      required: false,
      default: false,
    },
    errorMessage: {
      type: String as PropType<string>,
      required: false,
    },
    hideBottomSpace: {
      type: Boolean as PropType<boolean>,
      required: false,
      default: false,
    },
  },
  emits: ['update:modelValue'],
  setup(props, { emit }) {
    const { modelValue } = toRefs(props);
    const internalValue = ref(modelValue);

    watch(
      () => props.modelValue,
      (newValue: string) => {
        internalValue.value = newValue;
      }
    );

    function updateValue(value: string) {
      internalValue.value = value;
      emit('update:modelValue', value);
    }

    return {
      internalValue,
      updateValue,
    };
  },
});
</script>
